---
title: Number.prototype.toFixed()
slug: Web/JavaScript/Reference/Global_Objects/Number/toFixed
tags:
  - JavaScript
  - Method
  - Number
  - Prototype
  - Reference
---
<div>{{JSRef}}</div>

<p>The <strong><code>toFixed()</code></strong> method formats a number using fixed-point notation.</p>

<div>{{EmbedInteractiveExample("pages/js/number-tofixed.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>numObj</var>.toFixed([<var>digits</var>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>digits</var></code> {{optional_inline}}</dt>
 <dd>The number of digits to appear after the decimal point; this may be a value between <code>0</code> and <code>20</code>, inclusive, and implementations may optionally support a larger range of values. If this argument is omitted, it is treated as <code>0</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A string representing the given number using fixed-point notation.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>{{jsxref("RangeError")}}</dt>
 <dd>If <code><var>digits</var></code> is too small or too large. Values between <code>0</code> and <code>100</code>, inclusive, will not cause a {{jsxref("RangeError")}}. Implementations are allowed to support larger and smaller values as chosen.</dd>
 <dt>{{jsxref("TypeError")}}</dt>
 <dd>If this method is invoked on an object that is not a {{jsxref( "Number")}}.</dd>
</dl>

<h2 id="Description">Description</h2>

<p><strong><code>toFixed()</code></strong> returns a string representation of <code><var>numObj</var></code> that does not use exponential notation and has exactly <code><var>digits</var></code> digits after the decimal place. The number is rounded if necessary, and the fractional part is padded with zeros if necessary so that it has the specified length. If the absolute value of <code><var>numObj</var></code> is greater or equal to <code>1e+21</code>, this method calls {{jsxref("Number.prototype.toString()")}} and returns a string in exponential notation.</p>

<div class="warning">
<p><strong>Warning:</strong> Floating point numbers cannot represent all decimals precisely in binary. This can lead to unexpected results, such as <code>0.1 + 0.2 === 0.3</code> returning <code>false</code> .</p>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Using_toFixed">Using toFixed</h3>

<pre class="brush: js notranslate">let numObj = 12345.6789

numObj.toFixed()       // Returns '12346': note rounding, no fractional part
numObj.toFixed(1)      // Returns '12345.7': note rounding
numObj.toFixed(6)      // Returns '12345.678900': note added zeros
(1.23e+20).toFixed(2)  // Returns '123000000000000000000.00'
(1.23e-10).toFixed(2)  // Returns '0.00'
2.34.toFixed(1)        // Returns '2.3'
2.35.toFixed(1)        // Returns '2.4'. Note it rounds up
2.55.toFixed(1)        // Returns '2.5'. Note it rounds down - see warning above
-2.34.toFixed(1)       // Returns -2.3 (due to operator precedence, negative number literals don't return a string...)
(-2.34).toFixed(1)     // Returns '-2.3'
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-number.prototype.tofixed', 'Number.prototype.toFixed')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Number.toFixed")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Number.prototype.toExponential()")}}</li>
 <li>{{jsxref("Number.prototype.toPrecision()")}}</li>
 <li>{{jsxref("Number.prototype.toString()")}}</li>
</ul>
